--[[
	Version 4
	
	30.01.2020	Vereinfachte Version
	11.02.2020  Getestet und Veröffentlicht
	22.03.2020	Kleine Fehlerbehebung
	24.03.2020	Auslesen der Sensoren auf Dieter umgestellt
	31.03.2023	Neue Version 2023, zwei Akkus zur Auswahl
	
--]]

collectgarbage()
--------------------------------------------------------------------------------
-- Locale Parameter für die Application
--------------------------------------------------------------------------------

local lbl1, Vmin_str, Vmax_str, S_str, AS_str, PS_str, akkuw, akkuwas, Hoehenw, Hoehenws, hw, trans
local V, V1, V2, Vmax, Vmin, S, ASR, AAS, H_str, Hmax, Hmin, PS, VLC, Q1, Q2, Q3, VZ,VR,hg,ende, posf, poss
local alt1, VU, VR, posr, mem, maxmem, count, V1max, V2max, V1min, V2max 
local txr, txg, txb = 1, 1, 1  
local model, owner = " ", " "
local sensorID, sensorParam, stepSize, resetSwitch, timerSwitch, hoehe, inter, minAlt, altSwitch, step, oldStep, hSe, hSeId, hstep
local modelF_Zeit, akkuName, playedFileS, playedFileA, playedFileE, prevVal, mtimerSwitch, txfarbe, akkuSwitch1, akkuSwitch2, akkuSwitch3
local altitudeStep, altitudeGained		= 0, 0
local aktTime, startTime, newTime, sumTime, saveTime, value, resetSwitchState, timerSwitchState
local maktTime, mstartTime, mnewTime, msaveTime, mtimerSwitchState
local timerusSwitchState
local std, min, sek, sstd, smin, ssek, stmsek, minmsek, stmssek, minmssek, mstd, mmin, msek, mstmsek, mminmsek, varioa, motorv, motorh
local beginn, mbeginn, mtbeginn  = 0, 0, 0
local x1, y1, x2, y2, x3, y3, t
local d1, d2, d3, g, ih 	= 0, 0, 0, 0, 0
local playedType = 1

local shortAnn, shortAnnIndex, shortAnnSt 		= false
local sinkAn, sinkAnIndex, sinkAnSt				= false
local akkuws, akkuwsIndex, akkuwsSt, zusHoehe	= false
local sumTimeres, sumTimeresIndex, sumTimeresSt = false

local sensorId, vario_param, altitude_param
local sensorIndex = 0
local sensor_id_list = {}
local sensor_label_list = {}
local sensor_param_lists = {}

--------------------------------------------------------------------------------
---------- Übersetzungen
--------------------------------------------------------------------------------

local function setLanguage()
    local lng=system.getLocale()
    local file = io.readall("Apps/FSCockpit4/FSCockpit4.jsn")
    local obj = json.decode(file)
    if(obj) then
        trans = obj[lng] or obj[obj.default]
    end
end

--------------------------------------------------------------------------------
--------------- Zeichne Batterie
--------------------------------------------------------------------------------

local function drawBatt(Akku, drawOn, VA, AASA, SA, VUA) 
			
			lcd.setColor(255,255,255)						-- Füllfarbe
			lcd.drawFilledRectangle(270,19,40,76)			-- Füllung Batterie Body
			V = (math.floor(V*10))/10
			Vmax = (math.floor(Vmax*10))/10
			Vmin = (math.floor(Vmin*10))/10
			lcd.setColor(txr,txg,txb)
			lcd.drawText(262 - lcd.getTextWidth(FONT_BIG,string.format("%s V",V)),14,string.format("%s V",V),FONT_BIG)  -- Spannungsanzeige
			lcd.drawText(266 - lcd.getTextWidth(FONT_BIG,string.format("%s %%",PS)),36,string.format("%s %%",PS),FONT_BIG)  -- Spannungsanzeige
			lcd.setColor(190,190,190)								-- Farbe grau
			lcd.drawText(207 - lcd.getTextWidth(FONT_MINI,string.format("Max.")),60,string.format("Max."),FONT_MINI)
			lcd.setColor(txr,txg,txb)
			lcd.drawText(246 - lcd.getTextWidth(FONT_BIG,string.format("%s",Vmax)),56,string.format("%s",Vmax),FONT_BIG)
			lcd.drawText(262 - lcd.getTextWidth(FONT_BIG,string.format("V")),56,string.format("V"),FONT_BIG)
			lcd.setColor(190,190,190)								-- Farbe grau			
			lcd.drawText(205 - lcd.getTextWidth(FONT_MINI,string.format("Min.")),82,string.format("Min."),FONT_MINI)
			lcd.setColor(txr,txg,txb)
			lcd.drawText(246 - lcd.getTextWidth(FONT_BIG,string.format("%s",Vmin)),77,string.format("%s",Vmin),FONT_BIG)
			lcd.drawText(262 - lcd.getTextWidth(FONT_BIG,string.format("V")),77,string.format("V"),FONT_BIG)

			-- lcd.drawText(36 - lcd.getTextWidth(FONT_BIG,string.format("%s",motors)),77,string.format("%s",motors),FONT_BIG)
			-- lcd.drawText(76 - lcd.getTextWidth(FONT_BIG,string.format("%s",hstep)),77,string.format("%s",hstep),FONT_BIG)
			
			lcd.drawImage(268, 12, imagepnbat)				-- Batterie		
			lcd.setColor(0,0,0)								-- Farbe schwarz
			
			playTone(5000,100,100,0,0)
----------------------------------------------------------------------------------------------------------------------------------------------------			
			if drawOn == 1 then								-- Anzeige wenn Empfänger aus
				lcd.drawText(302 - lcd.getTextWidth(FONT_NORMAL,string.format("%s ",Akku)),53,string.format("%s ",Akku),FONT_NORMAL)  	-- Akku
				if(system.getTime() % 2 == 0) then
				lcd.drawImage(145, 8, imagepngso)	  		  
				end
----------------------------------------------------------------------------------------------------------------------------------------------------				
			else											-- Anzeige wenn Empfänger an
				chgY = 22+(76-(0.8*(VA-AASA)/((SA-AASA)/100)))
				chgH = 22+(75-chgY)
				if chgY < 22 then chgY = 22 end
				if chgH == 0 then chgH = 78 end
				if chgH > 75 then chgH = 75 end
								
				lcd.setColor(255,255,255)					-- Füllfarbe  
				lcd.drawFilledRectangle(270,20,40,76)		-- Füllung Batterie Body weiss
				if VUA == 1 then 
					lcd.setColor(0,196,0)					-- Farbe grün
					lcd.drawImage(152, 44, imagepngbattgr)	-- Batterie Symbol greun
				else
					lcd.setColor(238,044,044)				-- Farbe rot
					if(system.getTime() % 2 == 0) then
						lcd.drawImage(152, 44, imagepngbattrot)	-- Batterie Symbol rot
					end
					if akkuw == 1 then system.playFile(akkuwas,AUDIO_IMMEDIATE) end
					if akkuw == 1 then system.messageBox ("Akkuwarnung",3) end
					akkuw = 0							
				end
				lcd.drawFilledRectangle(270,chgY,40,chgH)	-- Batteriesymbol Füllung Body
				lcd.setColor(0,0,0)							-- Farbe schwarz
				lcd.drawImage(268, 12, imagepnbat)			-- Batterie
				lcd.drawText(302 - lcd.getTextWidth(FONT_NORMAL,string.format("%s ",Akku)),53,string.format("%s ",Akku),FONT_NORMAL)  	-- Akku			  	
				lcd.drawImage(145, 8, imagepngson)				
			end			
end

--------------------------------------------------------------------------------
--------------- Funktion Höhenwarnung
--------------------------------------------------------------------------------

		local function HWarnung(whoehe)
			if Hoehenw > 0 then
				if whoehe < Hoehenw then hw = 0 end
				if whoehe >= Hoehenw and hw == 0 then
					system.playFile(Hoehenws,AUDIO_IMMEDIATE) -- (Hoehenws,AUDIO_IMMEDIATE    "/Apps/FSCockpit4/Hoehenwarnung.wav")
					hw = 1
					system.messageBox ("Höhenwarnung",3)
				end	
				if whoehe >= Hoehenw then	
					if(system.getTime() % 2 == 0) then
					lcd.drawImage(145, 124, imagepnghw)
					end
				end	
			else
			 system.messageBox ("",0)
			end
		end

--------------------------------------------------------------------------------
-- Zeichnet das Telemtrie Fenster
--------------------------------------------------------------------------------

local function printTelemetry()

		if txfarbe == 0 then txfarbe = 1 end
		if txfarbe == 1 then 	
			txr,txg,txb = 0,0,0  -- Textfarbe schwarz
		end
		if txfarbe == 2 then
			txr,txg,txb = 255,255,255  -- Textfarbe weiß
		end
		if txfarbe == 3 then
			txr,txg,txb = 102,204,255  -- Textfarbe cyan
		end	
		
		lcd.setColor (90,103,122) -- (8,64,97) -- (28,71,103) -- (41,63,80) Hintergrundfarbe für Fenster
		lcd.drawFilledRectangle(1,1,136,110)						-- Füllung Fenster links oben
		lcd.drawFilledRectangle(1,112,136,49)						-- Füllung Fenster links unten
		lcd.drawFilledRectangle(138,1,41,159)						-- Füllung Fenster Mitte
		lcd.drawFilledRectangle(180,1,138,110)						-- Füllung Fenster rechts oben
		lcd.drawFilledRectangle(180,112,138,49)						-- Füllung Fenster rechts unten		
		lcd.setColor (255,255,255)
		lcd.drawRectangle (0,0,138,112,0)							-- Rahmen links oben
		lcd.drawRectangle (0,111,138,48,0)							-- Rahmen Fenster links unten
		lcd.drawRectangle (179,0,138,112,0)							-- Rahmen rechts oben
		lcd.drawRectangle (179,111,138,48,0)						-- Rahmen Fenster rechts unten
		lcd.drawRectangle (137,0,43,159)							-- Rahmen Fenster Mitte

		VU = 0
		if (PS_str == "-") then			
			akkuName = "Off"
			drawBatt (akkuName, 1, V, AAS, S, VU)
			if(system.getTime() % 2 == 0) then
			  lcd.drawImage(152, 48, imagepngbattrot)				-- Batterie Symbol rot	
			end
		else 
		VU = 0
			if (VR > ASR) then 
				VU = 1 
				akkuw = 1
				else
				VU = 0
			end 
			drawBatt (akkuName, 0, V, AAS, S, VU)	
		end
				
		if Hmax > 999 then Hmax = 999 end
		if altitudeGained > 999 then altitudeGained = 999 end
		if Hmin > 999 then Hmin = 999 end
		if hoehe > 999 then hoehe = 999 end
		
------------------------------------------------------------------------------- 
-- Zeichnet Höhenanzeige große Zahlen
------------------------------------------------------------------------------- 		
	
		posf 		= 0
		posr		= 0
		poss		= 0
		posminmax	= 0
				
		lcd.setColor(190,190,190)		
		
		HWarnung(hoehe)
		
		 -- hoehe = 30	--------------------------------- DEBUG !!!!!!! ----------------------------------------------------------
		
			ih = math.floor(hoehe)
			if ih < 0 then ih = math.abs(ih) end
	
			x1 = 90+posf		--123										-- 1. Stelle				
			y1 = 22
			x2 = 47+posf													-- 2. Stelle
			y2 = 22
			x3 = 6+posf														-- 3. Stelle
			y3 = 22
			g  = 1.5
			
			d1 = ih-((math.floor(ih/10))*10)
	
			temp = ih % 100
			d2 = temp/10
	
			temp = ih % 1000
			d3 = temp/100
			
		lcd.setColor(190,190,190)								-- Farbe grau
		lcd.drawText(69 - lcd.getTextWidth(FONT_MINI,string.format(trans.texthoehe))/2,2,string.format(trans.texthoehe),FONT_MINI)
		
		lcd.setColor(txr,txg,txb)
		-- lcd.setColor(255,255,255)								-- Farbe weiss
				
		local valueSwitchus = system.getInputsVal(timerusSwitch)
		if (valueSwitchus == 1) then
			lcd.setColor(190,190,190)
			lcd.drawText(253 - lcd.getTextWidth(FONT_MINI,trans.gflugzeit)/2,114,trans.gflugzeit,FONT_MINI)
			lcd.setColor(txr,txg,txb) -- lcd.setColor(255,255,255)
			local printSTime = string.format("%02d:%02d:%02d", sstd, smin, ssek)		
			lcd.drawText(312 - lcd.getTextWidth(FONT_MAXI,string.format("%s",printSTime)),122,string.format("%s",printSTime),FONT_MAXI) -- Gesammtzeit	
		else
			lcd.setColor(190,190,190)
			lcd.drawText(250 - lcd.getTextWidth(FONT_MINI,trans.flugzeit)/2,114,trans.flugzeit,FONT_MINI)
			lcd.setColor(txr,txg,txb) -- lcd.setColor(255,255,255)
			local printTime = string.format("%02d:%02d:%02d", std, min, sek)	
			lcd.drawText(312 - lcd.getTextWidth(FONT_MAXI,string.format("%s",printTime)),122,string.format("%s",printTime),FONT_MAXI)	-- Flugzeit
		end
		
		local valuemSwitchus = system.getInputsVal(mtimerusSwitch)
		if  (valuemSwitchus == 1) then
			lcd.setColor(190,190,190)
			lcd.drawText(65 - lcd.getTextWidth(FONT_MINI,trans.motortime)/2,114,trans.motortime,FONT_MINI)
			lcd.setColor(txr,txg,txb) -- lcd.setColor(255,255,255)
			local printTime = string.format("%02d:%02d", mmin, msek)	
			lcd.drawText(105 - lcd.getTextWidth(FONT_MAXI,string.format("%s",printTime)),122,string.format("%s",printTime),FONT_MAXI)	-- Motorlaufzeit	
		else
			lcd.setColor(190,190,190)
			lcd.drawText(69 - lcd.getTextWidth(FONT_MINI,string.format(trans.plushoehe))/2,114,string.format(trans.plushoehe),FONT_MINI)
			lcd.setColor(txr,txg,txb) -- lcd.setColor(255,255,255)
			lcd.drawText(105 - lcd.getTextWidth(FONT_MAXI,string.format("%s",altitudeGained)),122,string.format("%s",altitudeGained),FONT_MAXI)
		end
			
		
-------------------------------------- Große Zahlen ---------------------------------------------
---------------------------------------- 1. Stelle ----------------------------------------------
		
	if hoehe < 0 then lcd.setColor(238,044,044)	end									-- Farbe rot
	if d1 == 0 then
		lcd.drawImage(x1, y1, imagepn0)				-- Zahl 0
	elseif d1 == 1 then
		lcd.drawImage(x1, y1, imagepn1)				-- Zahl 1
	elseif d1 == 2 then
		lcd.drawImage(x1, y1, imagepn2)				-- Zahl 2
	elseif d1 == 3 then
		lcd.drawImage(x1, y1, imagepn3)				-- Zahl 3
	elseif d1 == 4 then
		lcd.drawImage(x1, y1, imagepn4)				-- Zahl 4
	elseif d1 == 5 then
		lcd.drawImage(x1, y1, imagepn5)				-- Zahl 5
	elseif d1 == 6 then
		lcd.drawImage(x1, y1, imagepn6)				-- Zahl 6
	elseif d1 == 7 then
		lcd.drawImage(x1, y1, imagepn7)				-- Zahl 7
	elseif d1 == 8 then
		lcd.drawImage(x1, y1, imagepn8)				-- Zahl 8
	elseif d1 == 9 then
		lcd.drawImage(x1, y1, imagepn9)				-- Zahl 9
	else
		lcd.drawImage(x1, y1, imagepn0)				-- Zahl 0
	end

---------------------------------------- 2. Stelle ----------------------------------------------
	
	if hoehe < 0 then lcd.setColor(238,044,044)	end									-- Farbe rot
	if d2 == 0 and d3 == 0 then
	elseif d2 == 0 then
		lcd.drawImage(x2, y2, imagepn0)				-- Zahl 0
	elseif d2 == 1 then
		lcd.drawImage(x2, y2, imagepn1)				-- Zahl 1
	elseif d2 == 2 then
		lcd.drawImage(x2, y2, imagepn2)				-- Zahl 2
	elseif d2 == 3 then
		lcd.drawImage(x2, y2, imagepn3)				-- Zahl 3
	elseif d2 == 4 then
		lcd.drawImage(x2, y2, imagepn4)				-- Zahl 4
	elseif d2 == 5 then
		lcd.drawImage(x2, y2, imagepn5)				-- Zahl 5
	elseif d2 == 6 then
		lcd.drawImage(x2, y2, imagepn6)				-- Zahl 6
	elseif d2 == 7 then
		lcd.drawImage(x2, y2, imagepn7)				-- Zahl 7
	elseif d2 == 8 then
		lcd.drawImage(x2, y2, imagepn8)				-- Zahl 8
	elseif d2 == 9 then
		lcd.drawImage(x2, y2, imagepn9)				-- Zahl 9
	else
		lcd.drawImage(x2, y2, imagepn0)				-- Zahl 0
	end
	
---------------------------------------- 3. Stelle ----------------------------------------------

	if d3 == 0 then
	elseif d3 == 0 then
		lcd.drawImage(x3, y3, imagepn0)				-- Zahl 0
	elseif d3 == 1 then
		lcd.drawImage(x3, y3, imagepn1)				-- Zahl 1
	elseif d3 == 2 then
		lcd.drawImage(x3, y3, imagepn2)				-- Zahl 4
	elseif d3 == 3 then
		lcd.drawImage(x3, y3, imagepn3)				-- Zahl 5
	elseif d3 == 4 then
		lcd.drawImage(x3, y3, imagepn4)				-- Zahl 6
	elseif d3 == 5 then
		lcd.drawImage(x3, y3, imagepn5)				-- Zahl 7
	elseif d3 == 6 then
		lcd.drawImage(x3, y3, imagepn6)				-- Zahl 8
	elseif d3 == 7 then
		lcd.drawImage(x3, y3, imagepn7)				-- Zahl 9
	elseif d3 == 8 then
		lcd.drawImage(x3, y3, imagepn8)				-- Zahl 9
	elseif d3 == 9 then
		lcd.drawImage(x3, y3, imagepn9)				-- Zahl 9
	else
		lcd.drawImage(x3, y3, imagepn0)				-- Zahl 9
	end	
		lcd.setColor(txr,txg,txb) -- lcd.setColor (255,255,255)
		
	lcd.setColor(238,044,044)										-- Farbe rot	
	if hoehe < 0 and d3 == 0 then 									-- Minus für Minushöhe
		lcd.drawFilledRectangle(40+posf,56,16*g,6*g) 
	end	
	
-----------------------------------------------------------------------------------
------------------------ Batteriesymbol ------------------------------------------- 
-----------------------------------------------------------------------------------
	
	if win5 == 1 then
			VU = 0
		if (PS_str == "-") then			
			akkuName = "Off"
			drawBatt (akkuName, 1, V, AAS, S, VU)			
		else 
			VU = 0
			if ((VR > ASR) and (V1 > AS1) and (V2 > AS2)) or 
			   ((VR > ASR) and (V1 == 0) and (V2 == 0)) or
			   ((VR > ASR) and (V1 == 0) and (V2 > AS2)) or 
			   ((VR > ASR) and (V1 > AS1) and (V2 == 0)) then 
				VU = 1 
				akkuw = 1
				else
				VU = 0
			end
			drawBatt (akkuName, 0, V, AAS, S, VU)			
		end
	end
				
---------------------------------------------------------------------------------
-- Flugzeit
---------------------------------------------------------------------------------	

local valueStart = system.getInputsVal(timerSwitch)
		
 	if (valueStart == 1) and beginn == 1 then
	
		saveTime 	= system.pLoad("sumtime",0)
		aktTime 	= system.getTimeCounter()- startTime
		ende 		= 1

	if prevVal == 0 then 
		system.playFile(playedFileS,AUDIO_BACKGROUND)
		prevVal = 1     
	end  		
		value = math.abs(aktTime)		
		sumTime = saveTime+value
		
			-- if(system.getTime() % 2 == 0) then
				lcd.drawImage(150, 88, imagepngtim)						-- Uhr
			-- end
	
--------------------------- Flugzeit -------------------------------------------------------
		
			newTime = math.abs(aktTime)
			------- Stunden
			std   = math.floor(newTime/3600000)
			------- Minuten
			stmsek = std*3600000
			min 	= math.floor(((newTime-stmsek)/1000)/60)
			------- Sekunden
			minmsek = math.floor((newTime-stmsek)/1000)
			sek = minmsek-(min*60)
			
------------------------- Gesamtzeit ------------------------------------------------------			

			sumTime = math.abs(sumTime)
			------- Stunden Gesamtzeit
			sstd   = math.floor(sumTime/3600000)
			------- Minuten Gesamtzeit
			stmssek = sstd*3600000
			smin 	= math.floor(((sumTime-stmssek)/1000)/60)
			------- Sekunden Gesamtzeit
			minmssek = math.floor((sumTime-stmssek)/1000)
			ssek = minmssek-(smin*60)
			
	else
	
		startTime = system.getTimeCounter()
		system.pSave("sumtime",sumTime)
		
		sumTime = math.abs(sumTime)
		------- Stunden Gesamtzeit
		sstd   = math.floor(sumTime/3600000)
		------- Minuten Gesamtzeit
		stmssek = sstd*3600000
		smin 	= math.floor(((sumTime-stmssek)/1000)/60)
		------- Sekunden Gesamtzeit
		minmssek = math.floor((sumTime-stmssek)/1000)
		ssek = minmssek-(smin*60)
		
		if prevVal == 0 and (valueStart == -1) and ende == 1 then 
			system.playFile(playedFileE,AUDIO_BACKGROUND)
			ende = 0
		end
		prevVal = 0 		
	end

---------------------------------------------------------------------------------
-- Motorlaufzeit
---------------------------------------------------------------------------------	

local mvalueStart = system.getInputsVal(mtimerSwitch)

		 if mbeginn == 1 then maktTime = system.getTimeCounter()- mstartTime end
		 if mbeginn == 0 then maktTime = (system.getTimeCounter()- mstartTime) + msaveTime end
		
		if (mvalueStart == 1) and mtbeginn == 1 then
			mnewTime = math.abs(maktTime)
			------- Stunden
			mstd   = math.floor(mnewTime/3600000)
			------- Minute
			mstmsek = mstd*3600000
			mmin 	= math.floor(((mnewTime-mstmsek)/1000)/60)
			------- Sekunden
			mminmsek = math.floor((mnewTime-mstmsek)/1000)
			msek = mminmsek-(mmin*60)
		
			mbeginn = 0
			msaveTime = mnewTime
			mstartTime = system.getTimeCounter()
		else	
			mstartTime = system.getTimeCounter()	
		end
	end	

--------------------------------------------------------------------------------
-- Speichert die Daten des gewählten Sensor im Modellspeicher
--------------------------------------------------------------------------------

local function sensorChanged(value)

if ( not sensor_id_list[1] ) then	-- no sensors found
		return
	end	
	sensorId  = sensor_id_list[value]
	system.pSave("sensorId", sensorId)
	sensorIndex = value
	hSePa  = 0  		-- prevent error if previous index was higher than possible in this new sensor
	form.reinit()
end

local function sensorhChanged(value)
	hSePa = value
	system.pSave("hSePa", hSePa)
end

local function sensorv1Changed(value)
	v1SePa = value
	system.pSave("v1SePa", v1SePa)
end

local function sensorv2Changed(value)
	v2SePa = value
	system.pSave("v2SePa", v2SePa)
end

local function stepSizeChanged(value)
	stepSize = value
	system.pSave("stepSize",stepSize)
end

local function spannChanged(value)
	spann = value
	system.pSave("spann", spann)
end

local function aspannChanged(value)
	aspann = value
	system.pSave("aspann", aspann)
end

local function aaspannChanged(value)
	aaspann = value
	system.pSave("aaspann", aaspann)
end

local function spann1Changed(value)
	spann1 = value
	system.pSave("spann1", spann1)
end

local function aspann1Changed(value)
	aspann1 = value
	system.pSave("aspann1", aspann1)
end

local function aaspann1Changed(value)
	aaspann1 = value
	system.pSave("aaspann1", aaspann1)
end

local function spann2Changed(value)
	spann2 = value
	system.pSave("spann2", spann2)
end

local function aspann2Changed(value)
	aspann2 = value
	system.pSave("aspann2", aspann2)
end

local function aaspann2Changed(value)
	aaspann2 = value
	system.pSave("aaspann2", aaspann2)
end

local function sumTimeChanged(value)
 	sumTime = value
	system.pSave("sumtime",sumTime)
end

local function fileChanged(value)
  playedFileS=value
  system.pSave("file",value)   
end

local function fileeChanged(value)
  playedFileE=value
  system.pSave("filee",value)   
end

local function akkuwasChanged(value)
  akkuwas=value
  system.pSave("akkuwas",value)   
end

local function hoehenwChanged(value)
  Hoehenw=value
  system.pSave("hoehenw",value)   
end

local function hoehenwsChanged(value)
  Hoehenws=value
  system.pSave("hoehenws",value)   
end

local function interChanged(value)
	inter = value
	system.pSave("inter",inter)
end

local function minAltChanged(value)
	minAlt = value
	system.pSave("minAlt",minAlt)
end

local function sinkAnClicked(value)
    local pSave = system.pSave
    sinkAn = not value
    form.setValue(sinkAnIndex, sinkAn)
    if(sinkAn) then
        pSave("sinkAnSt", 1)
        else
        pSave("sinkAnSt", 0)
    end
end

local function akkuwsClicked(value)
    local pSave = system.pSave
    akkuws = not value
    form.setValue(akkuwsIndex, akkuws)
    if(akkuws) then
        pSave("akkuwsSt", 1)
        else
        pSave("akkuwsSt", 0)
    end
end

local function sumTimeresClicked(value)
    local pSave = system.pSave
    sumTimeres = not value
    form.setValue(sumTimeresIndex, sumTimeres)
    if(sumTimeres) then
        pSave("sumTimeresSt", 1)
        else
        pSave("sumTimeresSt", 0)
    end
end

local function zusHoeheClicked(value)
    local pSave = system.pSave
    zusHoehe = not value
    form.setValue(zusHoeheIndex, zusHoehe)
    if(zusHoehe) then
        pSave("zusHoeheSt", 1)
        else
        pSave("zusHoeheSt", 0)
    end
end

local function txfarbeChanged(value)
	txfarbe = value
	system.pSave("txfarbe",txfarbe)
end

-- Schalter speichern --

-- local function akkuSwitch1Changed(value)
--	akkuSwitch1 = value
--    system.pSave("akkuSwitch1",value)
-- end

local function akkuSwitch2Changed(value)
	akkuSwitch2 = value
	system.pSave("akkuSwitch2",value)
end

local function akkuSwitch3Changed(value)
	akkuSwitch3 = value
	system.pSave("akkuSwitch3",value)
end

local function timerSwitchChanged(value)
	timerSwitch = value
	system.pSave("timerSwitch",value)
end

local function mtimerSwitchChanged(value)
	mtimerSwitch = value
	system.pSave("mtimerSwitch",value)
end

local function timerusSwitchChanged(value)
	timerusSwitch = value
	system.pSave("timerusSwitch",value)
end

local function mtimerusSwitchChanged(value)
	mtimerusSwitch = value
	system.pSave("mtimerusSwitch",value)
end

local function altSwitchChanged(value)
	altSwitch = value
	system.pSave("altSwitch",value)
end

local function resetSwitchChanged(value)
	resetSwitch = value
	system.pSave("resetSwitch",value)
end

--------------------------------------------------------------------------------
-- Setup Fenster
--------------------------------------------------------------------------------

local function initForm(subform)

		local form, addRow, addLabel = form, form.addRow ,form.addLabel
		local setButton = form.setButton
        local addIntbox, addCheckbox = form.addIntbox, form.addCheckbox
        local addSelectbox, addInputbox = form.addSelectbox, form.addInputbox
		local addAudioFilebox = form.addAudioFilebox
		
	local i, sensor
	
------------------------- Sensorliste von Dieter -------------------------------	
	
	if ( not sensor_id_list[1] ) then										-- sensors not yet checked or rebooted
		for i,sensor in ipairs(system.getSensors()) do
			if (sensor.param == 0) then										-- new multisensor/device
				sensor_label_list[#sensor_label_list + 1] = sensor.label 	-- list presented in sensor select box
				sensor_id_list[#sensor_id_list + 1] = sensor.id          	-- to get id from if sensor changed, same numeric indexing
				if (sensor.id == sensorId) then
					sensorIndex = #sensor_id_list
				end
				sensor_param_lists[#sensor_param_lists + 1] = {}           	-- start new param list only containing label and unit as string
			else                                                         	-- subscript is number of param for current multisensor/device
				sensor_param_lists[#sensor_param_lists][sensor.param] = sensor.label .. "  " .. sensor.unit -- list presented in param select box
			end
		end
	end	
	
-------------------------------------------------------------------------------			
				
	if(subform == 1) then
		setButton(1,trans.btn1,HIGHLIGHTED)
		setButton(2,trans.btn2,ENABLED)
		setButton(3,trans.btn3,ENABLED)
	
		addRow(1)
		addLabel({label=trans.sensSettings,font=FONT_BOLD})
		
		form.addRow(2)
		form.addLabel({label = "Gerät"})
		form.addSelectbox(sensor_label_list, sensorIndex, true, sensorChanged)

        if ( sensor_id_list and sensorIndex > 0 ) then	
			form.addRow(2)
			form.addLabel({label = trans.selecthsens})
			form.addSelectbox(sensor_param_lists[sensorIndex], hSePa, true, sensorhChanged)
			
			form.addRow(2)
			form.addLabel({label = trans.selects1sens})
			form.addSelectbox(sensor_param_lists[sensorIndex], v1SePa, true, sensorv1Changed)
			
			form.addRow(2)
			form.addLabel({label = trans.selects2sens})
			form.addSelectbox(sensor_param_lists[sensorIndex], v2SePa, true, sensorv2Changed)			
		end	
		
		addRow(1)
		addLabel({label="-------------------------------------------------------------------------",font=FONT_BOLD})		
						
		addRow(1)
		addLabel({label=trans.txtfarbe,font=FONT_BOLD})

		addRow(2)
		addLabel({label= trans.txfarbe, width=220})
		addIntbox(txfarbe, 1, 3, 1, 0, 1, txfarbeChanged)
		
		addRow(1)
		addLabel({label="-------------------------------------------------------------------------",font=FONT_BOLD})		
						
		addRow(1)
		addLabel({label=trans.schaltSettings,font=FONT_BOLD})
		
		addRow(2)
		addLabel({label= trans.schalterphoehe, width=220})
		addInputbox(resetSwitch,true,resetSwitchChanged)
		
		addRow(2)
		addLabel({label= trans.altSwitch, width=220})
		addInputbox(altSwitch,true,altSwitchChanged)
		
		addRow(2)
		addLabel({label= trans.schaltertimer, width=220})
		addInputbox(timerSwitch,true,timerSwitchChanged)
		
		addRow(2)
		addLabel({label= trans.schalterustimer, width=220})
		addInputbox(timerusSwitch,true,timerusSwitchChanged)
		
		addRow(2)
		addLabel({label= trans.schaltermtimer, width=220})
		addInputbox(mtimerSwitch,true,mtimerSwitchChanged)
		
		addRow(2)
		addLabel({label= trans.schalterusmtimer, width=220})
		addInputbox(mtimerusSwitch,true,mtimerusSwitchChanged)
		
		-- addRow(2)
		-- addLabel({label= trans.schalterspann1, width=220})
		-- addInputbox(akkuSwitch1,true,akkuSwitch1Changed)
		
		addRow(2)
		addLabel({label= trans.schalterspann2, width=220})
		addInputbox(akkuSwitch2,true,akkuSwitch2Changed)
		
		addRow(2)
		addLabel({label= trans.schalterspann3, width=220})
		addInputbox(akkuSwitch3,true,akkuSwitch3Changed)
		

		addRow(1)
		addLabel({label="-------------------------------------------------------------------------",font=FONT_BOLD})
		
		addRow(1)
		addLabel({label=trans.timerSettings,font=FONT_BOLD})
		
		addRow(2)
		addLabel({label= trans.startsound, width=220})
		addAudioFilebox(playedFileS or "", fileChanged)
		
		addRow(2)
		addLabel({label= trans.endsound, width=220})
		addAudioFilebox(playedFileE or "", fileeChanged)

		addRow(1)
		addLabel({label="-------------------------------------------------------------------------",font=FONT_BOLD})		
						
		addRow(1)
		addLabel({label=trans.gfzSettings,font=FONT_BOLD})
						
		addRow(2)
		addLabel({label= trans.loeschengfz, width=274})
		sumTimeresIndex = addCheckbox(sumTimeres, sumTimeresClicked)		
		
		form.setFocusedRow (1)
		formID = 1
		
		else
		if(subform == 2) then
		setButton(1,trans.btn1,ENABLED)
		setButton(2,trans.btn2,HIGHLIGHTED)
		setButton(3,trans.btn3,ENABLED)

		addRow(1)
		addLabel({label=trans.akkuSettings,font=FONT_BOLD})
							
		addRow(2)
		addLabel({label= trans.akkuwarnung, width=274})
		akkuwsIndex = addCheckbox(akkuws, akkuwsClicked)

		addRow(2)
		addLabel({label= trans.akkuwarnungs, width=220})
		addAudioFilebox(akkuwas or "", akkuwasChanged)		
				
		addRow(2)
		addLabel({label= trans.akkuspannung, width=220})
		addIntbox(spann, 0, 240, 2, 1, 1, spannChanged)
		
		addRow(2)
		addLabel({label= trans.alarmspannung, width=220})
		addIntbox(aspann, 0, 240, 2, 1, 1, aspannChanged)
		
		addRow(2)
		addLabel({label= trans.abschaltspannung, width=220})
		addIntbox(aaspann, 0, 240, 2, 1, 1, aaspannChanged)
		
		addRow(2)
		addLabel({label= trans.akkuspannung1, width=220})
		addIntbox(spann1, 0, 240, 2, 1, 1, spann1Changed)
		
		addRow(2)
		addLabel({label= trans.alarmspannung1, width=220})
		addIntbox(aspann1, 0, 240, 2, 1, 1, aspann1Changed)
		
		addRow(2)
		addLabel({label= trans.abschaltspannung1, width=220})
		addIntbox(aaspann1, 0, 240, 2, 1, 1, aaspann1Changed)
		
		addRow(2)
		addLabel({label= trans.akkuspannung2, width=220})
		addIntbox(spann2, 0, 240, 2, 1, 1, spann2Changed)
		
		addRow(2)
		addLabel({label= trans.alarmspannung2, width=220})
		addIntbox(aspann2, 0, 240, 2, 1, 1, aspann2Changed)
		
		addRow(2)
		addLabel({label= trans.abschaltspannung2, width=220})
		addIntbox(aaspann2, 0, 240, 2, 1, 1, aaspann2Changed)
					
		form.setFocusedRow (1)
		formID = 3
			
		else
		if(subform == 3) then
			setButton(1,trans.btn1,ENABLED)
			setButton(2,trans.btn2,ENABLED)
			setButton(3,trans.btn3,HIGHLIGHTED)
			
		addRow(1)
		addLabel({label=trans.hSettings,font=FONT_BOLD})		
		
		addRow(2)
		addLabel({label= trans.hoehenwarnung, width=220})
		addIntbox(Hoehenw, 0, 1000, 0, 0, 1, hoehenwChanged)
		
		addRow(2)
		addLabel({label= trans.hoehenwarnungs, width=220})
		addAudioFilebox(Hoehenws or "", hoehenwsChanged)

		addRow(2)
        addLabel({label= trans.interTr, width=220})
        addIntbox(inter, 0, 1000, 0, 0, 1, interChanged)

        addRow(2)        
        addLabel({label= trans.minAltTr, width=220})
        addIntbox(minAlt, -1000, 10000, 0, 0, 1, minAltChanged)
        
        form.addRow(2)
        addLabel({label= trans.sinkAnTr, width=270})
        sinkAnIndex = addCheckbox(sinkAn, sinkAnClicked)	
				
		addRow(2)
		addLabel({label= trans.schrittehoehe, width=220})
		addIntbox(stepSize, 0, 200, 1, 0, 1, stepSizeChanged)	

		form.setFocusedRow (1)
		formID = 4
	  end
	end
  end
end

local function keyPressed(key)
	if(key==KEY_1) then
		form.reinit(1)
	end
	if(key==KEY_2) then
		form.reinit(2)
	end
	if(key==KEY_3) then
		form.reinit(3)
	end
end

---------------------------------------------------------------------------------
-- Sensor und System auslesen und Werte berechnen
---------------------------------------------------------------------------------

local function loop()

system.registerTelemetry(1,lbl1.." - Modell: "..model,4,printTelemetry)

    local urx = system.getTxTelemetry ()	
		if urx.RSSI[1] > 0 and urx.RSSI[2] > 0 then
		
		VR = urx.rx1Voltage
	
			Q1 			= urx.RSSI[1]
			Q2 			= urx.RSSI[2]
			Q3 			= urx.rx1Percent
			beginn 		= 1
			mtbeginn 	= 1
			
			S 			= spann/10
			ASR			= aspann/10
			AAS 		= aaspann/10
			S1 			= spann1/10
			AS1			= aspann1/10
			AAS1 		= aaspann1/10
			S2 			= spann2/10
			AS2			= aspann2/10
			AAS2 		= aaspann2/10
			V 			= 0	
			
			local sensor = system.getSensorByID(sensorId, v1SePa)
			  if (not sensor) then return end
			   V1=math.floor(sensor.value)
			   if V1 <= 0 then V1 = 1 end
	
			local sensor = system.getSensorByID(sensorId, v2SePa)
			  if (not sensor) then return end
			   V2=math.floor(sensor.value)
			   if V2 <= 0 then V2 = 1 end	
			    
			   
		--[[
			
			local valueSwitch1 = system.getInputsVal(akkuSwitch1)
				if (valueSwitch1 == 1) then 
					V = urx.rx1Voltage
					V = (math.floor(V*100))/100
					akkuName = "RX"
					PS = (V-AAS)/((S-AAS)/100)
					PS = math.floor(PS)
					if PS > 100 then PS = 100 end
					if PS <=0 then PS = 0 end		
					PS_str 	= string.format("%.1f", PS)
					VR = V
				end	
				
		]]--
								
			local valueSwitch2 = system.getInputsVal(akkuSwitch2)
				if (valueSwitch2 == 1) then 
					V = V1
					V = (math.floor(V*100))/100					
					akkuName = "S1" 
					PS = (V-AAS1)/((S1-AAS1)/100)
					PS = math.floor(PS)
					if PS > 100 then PS = 100 end
					if PS <=0 then PS = 0 end					
					Vmax 	= V1max
					Vmin 	= V1min
					PS_str 	= string.format("%.1f", PS)
					S = S1
					AAS = AAS1
				end
				
			local valueSwitch3 = system.getInputsVal(akkuSwitch3)
				if (valueSwitch3 == 1) then
					V = V2  
					V = (math.floor(V*100))/100
					akkuName = "S2"
					PS = (V-AAS2)/((S2-AAS2)/100)
					PS = math.floor(PS)
					if PS > 100 then PS = 100 end
					if PS <=0 then PS = 0 end
					Vmax 	= V2max
					Vmin 	= V2min
					PS_str 		= string.format("%.1f", PS)
					S = S2
					AAS = AAS2
				end
			
			if V == 0 then 
				V = urx.rx1Voltage 
				V = (math.floor(V*100))/100
				akkuName = "RX"
				PS = (V-AAS)/((S-AAS)/100)
				PS = math.floor(PS)
				if PS > 100 then PS = 100 end
				if PS <=0 then PS = 0 end
				PS_str 	= string.format("%.1f", PS)
				VR = V
			end	
			
				if V <= 0 then V = 1 end
				
				-- Vmax = V
				-- Vmin = V
			
				if V > Vmax then Vmax = V end
				if V < Vmin then Vmin = V end			
				if Vmax <= 0 then Vmax	= urx.rx1Voltage end
				if Vmin <= 0 then Vmin	= urx.rx1Voltage end			
				
				VLC = V
				if VLC >= 10 then VLC = math.floor(V+0.5) end			
						
		else
			PS_str  	= "-"
			PS 			= 0
			VLC			= 0
			Q1 			= 0
			Q2 			= 0
			Q3 			= 0	
			beginn 		= 0
			mtbeginn 	= 0
			V			= 0
			V1			= 0
			V2			= 0
	end

---------------------------------------------------------------------------------
	
	local sensor = system.getSensorByID(sensorId, hSePa)
	
		if (not sensor) then return end

		if (resetSwitch) then
			local resetSwitchStateNew=system.getInputsVal(resetSwitch)
			if (resetSwitchState~=resetSwitchStateNew) then
			resetSwitchState=resetSwitchStateNew
			altitudeGained=0
			end
		end		
	
		if (sensor.value>altitudeStep+stepSize) then
			altitudeStep=altitudeStep+stepSize
			altitudeGained=altitudeGained+stepSize
		elseif (sensor.value<altitudeStep-stepSize) then
			altitudeStep=altitudeStep-stepSize
		end
		
		hoehe = math.floor(sensor.value)		
		
	if urx.RSSI[1] > 0 and urx.RSSI[2] > 0 then
		
		if hoehe > Hmax then Hmax = hoehe end
		if hoehe < Hmin then Hmin = hoehe end
				
		if Hmax <= 0 then Hmax		= hoehe end
		-- if Vmin <= 0 then Vmin		= hoehe end
		
		if hoehe > Hmax then Hmax = hoehe end
		if hoehe < Hmin then Hmin = hoehe end
		
		Hmax = math.floor(Hmax)
		Hmin = math.floor(Hmin)
		
		HWarnung(hoehe)

--------------------------------------------------------------------------------
-- Höhenansage
--------------------------------------------------------------------------------

	local swi  = system.getInputsVal(altSwitch)
		alt = math.floor(hoehe)
		if(swi and swi < 1) then
			hstep = 0
			oldStep = 0
		end
		
		if(swi and swi == 1 and alt >= minAlt) then
			hstep = (math.modf((alt/inter)))
				if(hstep > oldStep) and (alt > 0) then
					oldStep = hstep
					if alt == 0 then oldStep = 0 end
                    system.playNumber(alt, 0, "m")
                end
		
        if(sinkAn and hstep < oldStep) and (alt < 0) then
						oldStep = hstep
						if alt == 0 then oldStep = 0 end
						system.playNumber(alt, 0, "m")
		end
	end			
  end	
end
	
--------------------------------------------------------------------------------
-- Initialization
--------------------------------------------------------------------------------

local function init(code1)
    local pLoad, registerForm, registerTelemetry = system.pLoad, system.registerForm, system.registerTelemetry
	remaining 	= 100
	resSw 		= pLoad("resSw")
end

local function init()

	sensorID			= system.pLoad("sensorID",0)
	sensorParam			= system.pLoad("sensorParam",0)
	stepSize			= system.pLoad("stepSize",1)
	resetSwitch			= system.pLoad("resetSwitch")
	timerSwitch			= system.pLoad("timerSwitch")
	timerusSwitch		= system.pLoad("timerusSwitch")
	mtimerSwitch		= system.pLoad("mtimerSwitch")
	mtimerusSwitch		= system.pLoad("mtimerusSwitch")
	altSwitch			= system.pLoad("altSwitch")
	akkuSwitch1			= system.pLoad("akkuSwitch1")
	akkuSwitch2			= system.pLoad("akkuSwitch2")
	akkuSwitch3			= system.pLoad("akkuSwitch3")

	spann   			= system.pLoad("spann",0)
	aspann  			= system.pLoad("aspann",0)
	aaspann 			= system.pLoad("aaspann",0)
	spann1   			= system.pLoad("spann1",0)
	aspann1  			= system.pLoad("aspann1",0)
	aaspann1 			= system.pLoad("aaspann1",0)
	spann2   			= system.pLoad("spann2",0)
	aspann2  			= system.pLoad("aspann2",0)
	aaspann2 			= system.pLoad("aaspann2",0)
	saveTime 			= system.pLoad("sumtime",0)
	sumTime 			= system.pLoad("sumtime",0)
	sinkAnSt			= system.pLoad("sinkAnSt",0)
	mstartTime 			= system.getTimeCounter()
	msaveTime			= 0
	mnewTime			= 0
	varioa	 			= 0
	motorh 				= 0
	motorv 				= 0
	
	mem, maxmem, count = 0,0,0

	playedFileS			= system.pLoad("file","")
	playedFileE			= system.pLoad("filee","")
	akkuwsSt			= system.pLoad("akkuwsSt",0)
	zusHoeheSt			= system.pLoad("zusHoeheSt",0)
	akkuwas				= system.pLoad("akkuwas",0)
	Hoehenw				= system.pLoad("hoehenw",0)
	Hoehenws			= system.pLoad("hoehenws",0)
	inter 				= system.pLoad("inter", 0)
    minAlt 				= system.pLoad("minAlt", 0)
	
	
	hSePa 	= system.pLoad("hSePa", 0)
	v1SePa 	= system.pLoad("v1SePa", 0)
	v2SePa 	= system.pLoad("v2SePa", 0)
	hSePa	= system.pLoad("hSePa", 0)
	sensorId = system.pLoad("sensorId", 0)
	
	txfarbe				= system.pLoad("txfarbe", 0)
	
	if txfarbe == 0 then txfarbe = 1 end	
	
   if(sinkAnSt == 1) then
        sinkAn = true
        else
        sinkAn = false
    end
	
    if(akkuwsSt == 1) then
        akkuws = true
        else
        akkuws = false
    end
	
	if(sumTimeresSt == 1) then
        sumTimeres = true
        else
        sumTimeres = false
    end
	
	if(zusHoeheSt == 1) then
        zusHoehe = true
        else
        zusHoehe = false
    end
	
	if(varioOnSt == 1) then
        varioOn = true
        else
        varioOn = false
    end
	
	lbl1 		= "Flugsachen - Cockpit4 1.3"
	
	Vmax, Vmin, V, VR, VU, v1, v2, ASR, AS1, AS2, VLC, hoehe, motorv, motorh 	= 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	hstep, step, oldStep, t, Q1, Q2, StdFZ, MinFZ, aktTime, newTime, timeSet, actTime, Hmax, Hmin	= 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	std, min, sek, sstd, smin, ssek, value, prevVal, ende, posf, mstd, mmin, msek, msstd, msmin, mssek   = 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	V1min, V1max, V2min,V2max = 0, 0, 0, 0
	
	AS_str 		= "-"
	PS_str		= "-"
	heading 	= 180	
	headingS 	= 206
	startTime 	= system.getTimeCounter()
	
	akkuw		= 1
	akkuName 	= ""	
	
	system.registerTelemetry(1,lbl1,4,printTelemetry_V)
	
	system.registerForm(1,MENU_APPS,"FSCockpit4 Setup",initForm, keyPressed)
	
	imagepnbat 		= lcd.loadImage("Apps/FSCockpit4/batterie.png")
	imagepngp 		= lcd.loadImage("Apps/FSCockpit4/plane.jpg")
	imagepngso 		= lcd.loadImage("Apps/FSCockpit4/senderoff.png")
	imagepngson		= lcd.loadImage("Apps/FSCockpit4/senderon.png")
	imagepngtim		= lcd.loadImage("Apps/FSCockpit4/time.png")
	imagepngbattgr	= lcd.loadImage("Apps/FSCockpit4/batteriegruen.png")
	imagepngbattrot	= lcd.loadImage("Apps/FSCockpit4/batterierot.png")
	imagepnghw 		= lcd.loadImage("Apps/FSCockpit4/hwarnung.png")
	
	if txfarbe == 1 then 
		imagepn0 	= lcd.loadImage("Apps/FSCockpit4/0b.png")
		imagepn1 	= lcd.loadImage("Apps/FSCockpit4/1b.png")
		imagepn2 	= lcd.loadImage("Apps/FSCockpit4/2b.png")
		imagepn3 	= lcd.loadImage("Apps/FSCockpit4/3b.png")
		imagepn4 	= lcd.loadImage("Apps/FSCockpit4/4b.png")
		imagepn5 	= lcd.loadImage("Apps/FSCockpit4/5b.png")
		imagepn6 	= lcd.loadImage("Apps/FSCockpit4/6b.png")
		imagepn7 	= lcd.loadImage("Apps/FSCockpit4/7b.png")
		imagepn8 	= lcd.loadImage("Apps/FSCockpit4/8b.png")
		imagepn9 	= lcd.loadImage("Apps/FSCockpit4/9b.png")
	end	
	if txfarbe == 2 then 
		imagepn0 	= lcd.loadImage("Apps/FSCockpit4/0.png")
		imagepn1 	= lcd.loadImage("Apps/FSCockpit4/1.png")
		imagepn2 	= lcd.loadImage("Apps/FSCockpit4/2.png")
		imagepn3 	= lcd.loadImage("Apps/FSCockpit4/3.png")
		imagepn4 	= lcd.loadImage("Apps/FSCockpit4/4.png")
		imagepn5 	= lcd.loadImage("Apps/FSCockpit4/5.png")
		imagepn6 	= lcd.loadImage("Apps/FSCockpit4/6.png")
		imagepn7 	= lcd.loadImage("Apps/FSCockpit4/7.png")
		imagepn8 	= lcd.loadImage("Apps/FSCockpit4/8.png")
		imagepn9 	= lcd.loadImage("Apps/FSCockpit4/9.png")
	end
	if txfarbe == 3 then 
		imagepn0 	= lcd.loadImage("Apps/FSCockpit4/0c.png")
		imagepn1 	= lcd.loadImage("Apps/FSCockpit4/1c.png")
		imagepn2 	= lcd.loadImage("Apps/FSCockpit4/2c.png")
		imagepn3 	= lcd.loadImage("Apps/FSCockpit4/3c.png")
		imagepn4 	= lcd.loadImage("Apps/FSCockpit4/4c.png")
		imagepn5 	= lcd.loadImage("Apps/FSCockpit4/5c.png")
		imagepn6 	= lcd.loadImage("Apps/FSCockpit4/6c.png")
		imagepn7 	= lcd.loadImage("Apps/FSCockpit4/7c.png")
		imagepn8 	= lcd.loadImage("Apps/FSCockpit4/8c.png")
		imagepn9 	= lcd.loadImage("Apps/FSCockpit4/9c.png")
	end

	model 			= system.getProperty("Model")
	
collectgarbage()
end
--------------------------------------------------------------------------------
setLanguage()
collectgarbage()
return {init=init, loop=loop, author="Flugsachen.de", version="1.3", name= "FSCockpit4"}